/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Metodos_Ordenacion;

import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;

/**
 *
 * @author Usuario iTC
 */
public class Metodo_shell extends javax.swing.JFrame {

    /**
     * Creates new form Metodo_shell
     */
    public Metodo_shell() {
        initComponents();
        setLocationRelativeTo(null);
        
        setIconImage(new ImageIcon(getClass().getResource("/fotos/icono.jpg")).getImage());//PONER UN ICONO
        ((JPanel) getContentPane()).setOpaque(false);
        ImageIcon uno = new ImageIcon(this.getClass().getResource("/fotos/ci.jpeg"));
        JLabel fondo = new JLabel();
        fondo.setIcon(uno);
        getLayeredPane().add(fondo, JLayeredPane.FRAME_CONTENT_LAYER);
        fondo.setBounds(0, 0, uno.getIconWidth(), uno.getIconHeight());
        
        setVisible(true);
    }
    Integer A[];
    String cadena = "";
    Vector arreglo = new Vector();

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        TXTNANOSEGUNDOS = new javax.swing.JTextField();
        txtvector = new javax.swing.JTextField();
        TXTSEGUNDOS = new javax.swing.JTextField();
        LIMPIARNBOTON = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        AREASOLUCION = new javax.swing.JTextArea();
        jLabel6 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        TXTSOLUCIN = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        botoningresar = new javax.swing.JButton();
        txtelemento = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        lblProceso2 = new javax.swing.JLabel();
        lblProceso = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        txtpasadas = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Metodo Shell");

        txtvector.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtvectorActionPerformed(evt);
            }
        });

        LIMPIARNBOTON.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Wipes_24px.png"))); // NOI18N
        LIMPIARNBOTON.setText("LIMPIAR");
        LIMPIARNBOTON.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                LIMPIARNBOTONActionPerformed(evt);
            }
        });

        jLabel5.setText("PROCESO");

        AREASOLUCION.setColumns(20);
        AREASOLUCION.setRows(5);
        jScrollPane1.setViewportView(AREASOLUCION);

        jLabel6.setText("DATOS ORDENADOS");

        jLabel2.setFont(new java.awt.Font("Yu Gothic UI Semibold", 0, 18)); // NOI18N
        jLabel2.setText("METODO SHELL");

        jLabel3.setText("INGRESE ELEMENTO");

        botoningresar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Cancel_Last_Digit_24px.png"))); // NOI18N
        botoningresar.setText("INGRESAR");
        botoningresar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botoningresarActionPerformed(evt);
            }
        });

        txtelemento.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtelementoActionPerformed(evt);
            }
        });

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Bill_24px.png"))); // NOI18N
        jButton2.setText("ORDENAR");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel4.setText("DATOS DEL VECTOR");

        lblProceso2.setText("Tiempo ( en nanosegundos) ");

        lblProceso.setText("Tiempo ( en segundos) ");

        jLabel1.setText("Numero de pasadas");

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Unavailable_24px.png"))); // NOI18N
        jButton3.setText("SALIR");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(TXTSOLUCIN, javax.swing.GroupLayout.PREFERRED_SIZE, 321, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(50, 50, 50)
                        .addComponent(LIMPIARNBOTON)
                        .addGap(18, 18, 18)
                        .addComponent(jButton3)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtvector)
                                .addGap(47, 47, 47))
                            .addComponent(txtelemento, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 321, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(32, 32, 32)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblProceso2, javax.swing.GroupLayout.PREFERRED_SIZE, 246, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(TXTNANOSEGUNDOS, javax.swing.GroupLayout.PREFERRED_SIZE, 196, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblProceso)
                            .addComponent(botoningresar)
                            .addComponent(jLabel1)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(txtpasadas, javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(TXTSEGUNDOS, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 196, Short.MAX_VALUE))
                            .addComponent(jButton2))))
                .addGap(51, 51, 51))
            .addGroup(layout.createSequentialGroup()
                .addGap(307, 307, 307)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 147, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtelemento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(botoningresar))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(txtvector, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel5)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 158, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(29, 29, 29)
                        .addComponent(lblProceso2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(TXTNANOSEGUNDOS, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(lblProceso)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(TXTSEGUNDOS, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel1)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(txtpasadas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(TXTSOLUCIN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(LIMPIARNBOTON)
                    .addComponent(jButton3))
                .addGap(30, 30, 30))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void botoningresarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botoningresarActionPerformed
        // TODO add your handling code here:
        cadena += txtelemento.getText();
        txtelemento.requestFocus();
        arreglo.add(txtelemento.getText());
        txtvector.setText(arreglo + " ");
        txtelemento.setText("");
        System.out.println(cadena);
    }//GEN-LAST:event_botoningresarActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        long inc = System.nanoTime();
        
        Vector presentar = new Vector();
        
        A = new Integer[cadena.length()];
        System.out.println(cadena
        );
        System.out.println(cadena.length());
        
        for (int i = 0; i < cadena.length(); i++) {
            String a = Character.toString(cadena.charAt(i));
            A[i] = Integer.parseInt(a);
            
        }
        txtvector.setText("" + arreglo);
        
        int salto, aux, i, tamaño, cont = 1;
        
        boolean cambios;
        for (salto = A.length / 2; salto != 0; salto /= 2) {
            cambios = true;
            while (cambios) { // Mientras se intercambie algún elemento
                cambios = false;
                for (i = salto; i < A.length; i++) // se da una pasada
                {
                    
                    if (A[i - salto] > A[i]) { // y si están desordenados
                        presentar.add("Pasada " + (cont));
                        presentar.add("\n");
                        presentar.add("______________");
                        cont++;
                        presentar.add("\n");
                        
                        String cadenita = " ";
                        for (int h = 0; h < A.length; h++) {
                            System.out.print(A[h]);
                            cadenita += A[h];
                        }
                        presentar.add(cadenita);
                        presentar.add("\n");
                        
                        aux = A[i]; // se reordenan
                        A[i] = A[i - salto];
                        A[i - salto] = aux;
                        cambios = true; // y se marca como cambio.
                    }
                }
            }
        }
        
        arreglo.removeAll(arreglo);
        for (int h = 0; h < A.length; h++) {
            arreglo.add(A[h]);
        }
        
        TXTSOLUCIN.setText(" " + arreglo);
        
        long inicio = System.nanoTime();
        long inicio2 = System.nanoTime();
        long fin = System.nanoTime();
        long fin2 = System.nanoTime();
        double tiempoEjecucion = (double) (fin - inc) * 1.0e-9;
        double timeEjecion2 = (double) (fin2 - inc);
       
       
        TXTSEGUNDOS.setText(tiempoEjecucion + "");
        TXTNANOSEGUNDOS.setText(timeEjecion2 +"");
        AREASOLUCION.setText(presentar + " ");
      
        
        txtpasadas.setText(cont + "");
        

    }//GEN-LAST:event_jButton2ActionPerformed

    private void LIMPIARNBOTONActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_LIMPIARNBOTONActionPerformed
        // TODO add your handling code here:
        TXTNANOSEGUNDOS.setText("");
        TXTSEGUNDOS.setText("");
        TXTSOLUCIN.setText("");
        txtvector.setText("");
        AREASOLUCION.setText("");
        arreglo.clear();
        for (int i = 0; i < A.length; i++) {
            A[i] = null;
        }
        cadena = "";
        txtpasadas.setText("");
    }//GEN-LAST:event_LIMPIARNBOTONActionPerformed

    private void txtelementoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtelementoActionPerformed
        // TODO add your handling code here:e
        txtelemento.requestFocus();
    }//GEN-LAST:event_txtelementoActionPerformed

    private void txtvectorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtvectorActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtvectorActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        Principal a = new Principal();
        a.setVisible(true);

        hide(); 
    }//GEN-LAST:event_jButton3ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Metodo_shell.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Metodo_shell.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Metodo_shell.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Metodo_shell.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Metodo_shell().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea AREASOLUCION;
    private javax.swing.JButton LIMPIARNBOTON;
    private javax.swing.JTextField TXTNANOSEGUNDOS;
    private javax.swing.JTextField TXTSEGUNDOS;
    private javax.swing.JTextField TXTSOLUCIN;
    private javax.swing.JButton botoningresar;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblProceso;
    private javax.swing.JLabel lblProceso2;
    private javax.swing.JTextField txtelemento;
    private javax.swing.JTextField txtpasadas;
    private javax.swing.JTextField txtvector;
    // End of variables declaration//GEN-END:variables
}
